let defaultOptions = {
    container: null,
    filters: null,
    hideTexts: null,
    textPosition: "top",
    linesOrientation: "horizontal",
    rotate: 0,
    arrayBackgroundColorText: null,
    arrayColorText: null,
    linesColor: null
}
  , Dics = function(t) {
    this.options = utils.extend({}, [defaultOptions, t], {
        clearEmpty: !0
    }),
    this.container = this.options.container,
    null == this.container ? console.error("Container element not found!") : (this._setOrientation(this.options.linesOrientation, this.container),
    this.images = this._getImages(),
    this.sliders = [],
    this._activeSlider = null,
    this._load(this.images[0]))
};
Dics.prototype._load = function(t, i=1e5) {
    t.naturalWidth ? (this._buidAfterFirstImageLoad(t),
    window.addEventListener("resize", ()=>{
        this._setContainerWidth(t),
        this._resetSizes()
    }
    )) : i > 0 ? (i--,
    setTimeout(()=>{
        this._load(t, i)
    }
    , 100)) : console.error("error loading images")
}
,
Dics.prototype._buidAfterFirstImageLoad = function(t) {
    this._setContainerWidth(t),
    this._build(),
    this._setEvents()
}
,
Dics.prototype._setContainerWidth = function(t) {
    this.options.container.style.height = `${this._calcContainerHeight(t)}px`
}
,
Dics.prototype._setOpacityContainerForLoading = function(t) {
    this.options.container.style.opacity = t
}
,
Dics.prototype._resetSizes = function() {
    let t = this.images.length
      , i = this.container.getBoundingClientRect()[this.config.sizeField] / t;
    const e = this.container.querySelectorAll("[data-function='b-dics__section']");
    for (let t = 0; t < e.length; t++) {
        let s = e[t];
        s.style.flex = `0 0 ${i}px`,
        s.querySelector(".b-dics__image").style[this.config.positionField] = `${t * -i}px`;
        const o = s.querySelector(".b-dics__slider");
        o && (o.style[this.config.positionField] = `${i * (t + 1)}px`)
    }
}
,
Dics.prototype._build = function() {
    let t = this;
    t._applyGlobalClass(t.options);
    let i = t.images.length
      , e = t.container.getBoundingClientRect()[t.config.sizeField] / i;
    for (let s = 0; s < i; s++) {
        let o = t.images[s]
          , n = t._createElement("div", "b-dics__section")
          , l = t._createElement("div", "b-dics__image-container")
          , c = t._createSlider(s, e);
        t._createAltText(o, s, l),
        t._applyFilter(o, s, t.options.filters),
        t._rotate(o, l),
        n.setAttribute("data-function", "b-dics__section"),
        n.style.flex = `0 0 ${e}px`,
        o.classList.add("b-dics__image"),
        n.appendChild(l),
        l.appendChild(o),
        s < i - 1 && n.appendChild(c),
        t.container.appendChild(n),
        o.style[this.config.positionField] = `${s * -e}px`
    }
    this.sections = this._getSections(),
    this._setOpacityContainerForLoading(1)
}
,
Dics.prototype._getImages = function() {
    return this.container.querySelectorAll("img")
}
,
Dics.prototype._getSections = function() {
    return this.container.querySelectorAll('[data-function="b-dics__section"]')
}
,
Dics.prototype._createElement = function(t, i) {
    let e = document.createElement(t);
    return e.classList.add(i),
    e
}
,
Dics.prototype._setEvents = function() {
    let t = this;
    t._disableImageDrag(),
    t._isGoingRight = null;
    let i = 0
      , e = function(e) {
        let s = e.pageX ? e.pageX : e.touches[0].pageX;
        s < i ? t._isGoingRight = !1 : s > i && (t._isGoingRight = !0),
        i = s;
        let o = t._calcPosition(e)
          , n = o - t._beforeSectionsWidth(t.sections, t.images, t._activeSlider);
        t.sliders[t._activeSlider].style[t.config.positionField] = `${o}px`,
        t._pushSections(n, o)
    };
    t.container.addEventListener("click", e);
    for (let i = 0; i < t.sliders.length; i++) {
        let s = t.sliders[i];
        utils.setMultiEvents(s, ["mousedown", "touchstart"], function(o) {
            t._activeSlider = i,
            t._clickPosition = t._calcPosition(o),
            s.classList.add("b-dics__slider--active"),
            utils.setMultiEvents(t.container, ["mousemove", "touchmove"], e)
        })
    }
    utils.setMultiEvents(document.body, ["mouseup", "touchend"], function() {
        let i = t.container.querySelectorAll(".b-dics__slider--active");
        for (let s of i)
            s.classList.remove("b-dics__slider--active"),
            utils.removeMultiEvents(t.container, ["mousemove", "touchmove"], e)
    })
}
,
Dics.prototype._beforeSectionsWidth = function(t, i, e) {
    let s = 0;
    for (let i = 0; i < t.length; i++) {
        let o = t[i];
        if (i === e)
            return s;
        s += o.getBoundingClientRect()[this.config.sizeField]
    }
}
,
Dics.prototype._calcContainerHeight = function(t) {
    let i = t.naturalHeight
      , e = t.naturalWidth;
    return this.options.container.getBoundingClientRect().width / e * i
}
,
Dics.prototype._setLeftToImages = function(t, i) {
    let e = 0;
    for (let s = 0; s < i.length; s++) {
        i[s].style[this.config.positionField] = `-${e}px`,
        e += t[s].getBoundingClientRect()[this.config.sizeField],
        this.sliders[s].style[this.config.positionField] = `${e}px`
    }
}
,
Dics.prototype._disableImageDrag = function() {
    for (let t = 0; t < this.images.length; t++)
        this.sliders[t].addEventListener("dragstart", function(t) {
            t.preventDefault()
        }),
        this.images[t].addEventListener("dragstart", function(t) {
            t.preventDefault()
        })
}
,
Dics.prototype._applyFilter = function(t, i, e) {
    e && (t.style.filter = e[i])
}
,
Dics.prototype._applyGlobalClass = function(t) {
    let i = t.container;
    t.hideTexts && i.classList.add("b-dics--hide-texts"),
    "vertical" === t.linesOrientation && i.classList.add("b-dics--vertical"),
    "center" === t.textPosition ? i.classList.add("b-dics--tp-center") : "bottom" === t.textPosition ? i.classList.add("b-dics--tp-bottom") : "left" === t.textPosition ? i.classList.add("b-dics--tp-left") : "right" === t.textPosition && i.classList.add("b-dics--tp-right")
}
,
Dics.prototype._createSlider = function(t, i) {
    let e = this._createElement("div", "b-dics__slider");
    return this.options.linesColor && (e.style.color = this.options.linesColor),
    e.style[this.config.positionField] = `${i * (t + 1)}px`,
    this.sliders.push(e),
    e
}
,
Dics.prototype._createAltText = function(t, i, e) {
    let s = t.getAttribute("alt");
    if (s) {
        let t = this._createElement("p", "b-dics__text");
        this.options.arrayBackgroundColorText && (t.style.backgroundColor = this.options.arrayBackgroundColorText[i]),
        this.options.arrayColorText && (t.style.color = this.options.arrayColorText[i]),
        t.appendChild(document.createTextNode(s)),
        e.appendChild(t)
    }
}
,
Dics.prototype._rotate = function(t, i) {
    t.style.rotate = `-${this.options.rotate}`,
    i.style.rotate = this.options.rotate
}
,
Dics.prototype._removeActiveElements = function() {
    let t = Dics.container.querySelectorAll(".b-dics__slider--active");
    for (let i of t)
        i.classList.remove("b-dics__slider--active"),
        utils.removeMultiEvents(Dics.container, ["mousemove", "touchmove"], Dics.prototype._removeActiveElements)
}
,
Dics.prototype._setOrientation = function(t) {
    this.config = {},
    "vertical" === t ? (this.config.offsetSizeField = "offsetHeight",
    this.config.offsetPositionField = "offsetTop",
    this.config.sizeField = "height",
    this.config.positionField = "top",
    this.config.clientField = "clientY",
    this.config.pageField = "pageY") : (this.config.offsetSizeField = "offsetWidth",
    this.config.offsetPositionField = "offsetLeft",
    this.config.sizeField = "width",
    this.config.positionField = "left",
    this.config.clientField = "clientX",
    this.config.pageField = "pageX")
}
,
Dics.prototype._calcPosition = function(t) {
    let i = this.container.getBoundingClientRect()
      , e = isNaN(t[this.config.clientField]) ? t.touches[0][this.config.clientField] : t[this.config.clientField];
    return i[this.config.positionField] < e ? e - i[this.config.positionField] : 0
}
,
Dics.prototype._pushSections = function(t, i) {
    this._setFlex(i, this._isGoingRight);
    let e = this.sections[this._activeSlider]
      , s = this.sections[this._activeSlider + 1]
      , o = s.getBoundingClientRect()[this.config.sizeField] - (t - this.sections[this._activeSlider].getBoundingClientRect()[this.config.sizeField]);
    e.style.flex = !0 === this._isGoingRight ? `2 0 ${t}px` : `1 1 ${t}px`,
    s.style.flex = !0 === this._isGoingRight ? ` ${o}px` : `2 0 ${o}px`,
    this._setLeftToImages(this.sections, this.images)
}
,
Dics.prototype._setFlex = function(t, i) {
    let e = 0;
    for (let s = 0; s < this.sections.length; s++) {
        let o = this.sections[s];
        const n = o.getBoundingClientRect()[this.config.sizeField];
        e += n,
        i && t > e - n && s > this._activeSlider || !i && t < e && s < this._activeSlider ? o.style.flex = `1 100 ${n}px` : o.style.flex = `0 0 ${n}px`
    }
}
;
let utils = {
    extend: function(t, i, e) {
        for (let e in i)
            i.hasOwnProperty(e) && s(t, i[e]);
        function s(t, i) {
            for (let o in i)
                if (i.hasOwnProperty(o)) {
                    let n = i[o];
                    if ("Object" === utils.getConstructor(n))
                        t[o] || (t[o] = {}),
                        s(t[o], n);
                    else {
                        if (e.clearEmpty && null == n)
                            continue;
                        t[o] = n
                    }
                }
        }
        return t
    },
    setMultiEvents: function(t, i, e) {
        for (let s = 0; s < i.length; s++)
            t.addEventListener(i[s], e)
    },
    removeMultiEvents: function(t, i, e) {
        for (let s = 0; s < i.length; s++)
            t.removeEventListener(i[s], e, !1)
    },
    getConstructor: function(t) {
        return Object.prototype.toString.call(t).slice(8, -1)
    }
};

